
extends RigidBody2D

# member variables here, example:
# var a=2
# var b="textvar"

#var particleInstance
var timer
var waterhitInstance
var crashWavesInstance
var dieTimer
var muriendo

func _ready():
	# Called every time the node is added to the scene.
	# Initialization here
	set_fixed_process(true)
	set_contact_monitor( true )
	set_max_contacts_reported( 5 )
	connect("body_enter",self,"collision")
	#particleInstance = preload("res://Object Scenes/Oleaje.tscn")
	waterhitInstance = preload("res://Object Scenes/WaterHit.tscn")
	crashWavesInstance = preload("res://Object Scenes/CrashWaves.tscn")
	timer = 0.0
	muriendo = false
	dieTimer = 1.0

func _fixed_process(delta):
	timer += delta
	if get_pos().y > get_viewport().get_rect().size.height && get_linear_velocity().y > 0:
		set_linear_velocity(Vector2(get_linear_velocity().x,get_linear_velocity().y * -1))
	if get_pos().y < 0 && get_linear_velocity().y < 0:
		set_linear_velocity(Vector2(get_linear_velocity().x,get_linear_velocity().y * -1))
	set_angle()
	
	if muriendo:
		dieTimer -= delta
		if dieTimer < 0:
			queue_free()


func set_angle():
	set_rot( get_linear_velocity().angle())
	get_node("Particles2D").set_param(Particles2D.PARAM_INITIAL_ANGLE, get_rotd()+180)

func collision(body):
	if body.get_meta("type") != get_meta("type"):
		var crash = crashWavesInstance.instance()
		get_parent().add_child(crash)
		startDie()
		#queue_free()
	if body.get_meta("type") == "Jugador":
		body.vidaMenos()
		var waterhit = waterhitInstance.instance()
		get_parent().add_child(waterhit)
		startDie()
		#queue_free()

func startDie():
	set_rotd(get_rotd()-90)
	muriendo = true
	get_node("Sprite").hide()
	get_node("glass").hide()
	set_layer_mask(0)
	set_collision_mask(0)